<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { ActionMode, createActionDispatcher } from "../actionUtils";
  import { suits } from "../serverUtils";
  import InlineRank from "./icons/InlineRank.svelte";
  import InlineSuit from "./icons/InlineSuit.svelte";

  const dispatchEvent = createEventDispatcher();

  function dispatchChangeMode(mode: ActionMode | null): void {
    dispatchEvent("changeMode", mode);
  }

  const actionDispatcher = createActionDispatcher();

  export let state: GameState;
  export let userId: PlayerId;

  let selectedTarget: PlayerId | null = null;
  let selectedHintType: Hint | null = null;

  const handleRankClick = (rank: Rank) => (_evt: Event) => {
    selectedHintType = ["Rank", { rank }];
  };

  const handleSuitClick = (suit: Suit) => (_evt: Event) => {
    selectedHintType = ["Suit", { suit }];
  };

  const ranks: Rank[] = [1, 2, 3, 4, 5];
</script>

<h3>Give hint to a player</h3>
<div class="hint-inputs">
  <ul>
    {#each state.players.filter((p) => p.id !== userId) as player}
      <li>
        <label class="hint-target">
          <input
            type="radio"
            name="hint-target"
            bind:group={selectedTarget}
            value={player.id}
          />
          <gs6-user userid={player.id} />
        </label>
      </li>
    {/each}
  </ul>
  <ul>
    {#each ranks as rank}
      <li>
        <label class="rank-hint">
          <input
            type="radio"
            name="hint-type"
            on:click={handleRankClick(rank)}
          />
          <InlineRank {rank} />
        </label>
      </li>
    {/each}
  </ul>
  <ul>
    {#each suits as suit}
      <li>
        <label class="suit-hint">
          <input
            type="radio"
            name="hint-type"
            on:click={handleSuitClick(suit)}
          />
          <InlineSuit {suit} />
        </label>
      </li>
    {/each}
  </ul>
</div>
<div class="hint-buttons">
  <button class="secondary" on:click={() => dispatchChangeMode(null)}>
    Cancel
  </button>
  <button
    class="primary"
    disabled={selectedTarget === null || selectedHintType === null}
    on:click={() => {
      if (selectedTarget !== null && selectedHintType !== null) {
        actionDispatcher([
          "Hint",
          { target: selectedTarget, hint: selectedHintType },
        ]);
      }
    }}
  >
    OK
  </button>
</div>

<style>
  h3 {
    text-align: center;
  }

  .hint-target {
    display: inline-block;
    margin-block-start: 0.1em;
    margin-block-end: 0.1em;
  }

  .hint-inputs {
    display: flex;
    align-items: center;
    justify-content: space-between;
  }

  .suit-hint {
    white-space: nowrap;
  }

  .hint-buttons {
    text-align: center;
  }
</style>
